<script setup>
import { defineProps, ref, reactive, onMounted } from "vue";
import { store } from '@/store.js';
const props = defineProps({
    type: Number,
});
const emit = defineEmits(['torched']);
let basic = reactive({
    value: props.tabBasic,
});
const search = reactive({
    value: '',
});
const answer = reactive({
    items: [],
});
const searchResults = async (trait, string) => {
    if (string) {
        let response = await axios.post('/search/' + trait, {
            search: string,
        }, {
            headers: {
                'Content-Type': 'multipart/form-data'
            }
        });

        for (let item in response.data) {
            response.data[item].type = basic.value;
        }
        answer.items = response.data;
    }
}
const addItem = (item) => {
    let newItem = {};
    newItem.id = item.id;
    newItem.name = item.name;
    newItem.article = item.article;
    newItem.type = item.type;
    newItem.measure_unit = item.measureunit.short_name;
    newItem.amount = item.amount ?? 1;
    emit('torched', newItem)
    store.detail.active = 0;
}
</script>
<template>
    <div class="popup" :class="{ '_active': store.detail.active }">
        <div class="overlay" @click="store.detail.active = 0">

        </div>
        <div class="container">
            <div class="popup__content">
                <div class="popup__name">
                    Выберите позицию
                </div>
                <div class="popup__search">
                    <input @keyup="searchResults(basic.value, search.value)" class="popup__input input-styled"
                        v-model="search.value" placeholder="Введите наименование или артикул для поиска">
                </div>
                <div class="popup__results">
                    <div class="noresult" v-if="!answer['items'].length">
                        <div v-if="!search.value">
                            Для получения результатов выберите категорию и заполните строку поиска
                        </div>
                        <div v-else>
                            Результатов не найдено
                        </div>
                    </div>
                    <template v-else>
                        <div class="result">
                                <div class="result__article">Категория</div>
                                <div class="result__article">Артикул</div>
                                <div class="result__article">Фото</div>
                                <div class="result__name">Название</div>
                                <div class="result__article _centered">Материал</div>
                                <div class="result__article _centered">Ед. изм</div>
                                <div class="result__article _centered">Количество</div>
                                <div class="result__title result__button">Действия</div>
                            </div>
                        <template v-for="item in answer['items']">
                            <div class="result">
                                <div class="result__article">{{ types[item.type].name }}</div>
                                    <div class="result__article">{{ item.article }}</div>
                                    <div class="result__article"><img v-if="item.image" :src="item.image"></div>
                                    <div class="result__name">{{ item.name }}</div>
                                    <div class="result__article _centered">{{
        $page['props']['materials'][item.material_id - 1].short_name }}</div>
                                    <div class="result__article _centered">{{
        $page['props']['measure_units'][item.measure_unit_id - 1].short_name }}</div>
                                    <div class="result__article _centered"><input class="result_input" type="number"
                                            v-model="item.amount"></div>
                                    <div class="result__button" @click="addItem(item)">Добавить</div>
                            </div>
                        </template>
                    </template>
                </div>
            </div>
        </div>
    </div>
</template>
